// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: device_properties.proto

#include "device_properties.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)
namespace mascot {
class ReadDevicePropertiesMessageDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<ReadDevicePropertiesMessage>
      _instance;
} _ReadDevicePropertiesMessage_default_instance_;
class DeviceProperties_PropertiesEntry_DoNotUseDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceProperties_PropertiesEntry_DoNotUse>
      _instance;
} _DeviceProperties_PropertiesEntry_DoNotUse_default_instance_;
class DevicePropertiesDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceProperties>
      _instance;
} _DeviceProperties_default_instance_;
class ReadDeviceAttributeMetaMessageDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<ReadDeviceAttributeMetaMessage>
      _instance;
} _ReadDeviceAttributeMetaMessage_default_instance_;
class DeviceAttributeMeta_MetaEntry_DoNotUseDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceAttributeMeta_MetaEntry_DoNotUse>
      _instance;
} _DeviceAttributeMeta_MetaEntry_DoNotUse_default_instance_;
class DeviceAttributeMetaDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceAttributeMeta>
      _instance;
} _DeviceAttributeMeta_default_instance_;
}  // namespace mascot
namespace protobuf_device_5fproperties_2eproto {
void InitDefaultsReadDevicePropertiesMessageImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_ReadDevicePropertiesMessage_default_instance_;
    new (ptr) ::mascot::ReadDevicePropertiesMessage();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::ReadDevicePropertiesMessage::InitAsDefaultInstance();
}

void InitDefaultsReadDevicePropertiesMessage() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsReadDevicePropertiesMessageImpl);
}

void InitDefaultsDeviceProperties_PropertiesEntry_DoNotUseImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_value_2eproto::InitDefaultsAttributeValue();
  {
    void* ptr = &::mascot::_DeviceProperties_PropertiesEntry_DoNotUse_default_instance_;
    new (ptr) ::mascot::DeviceProperties_PropertiesEntry_DoNotUse();
  }
  ::mascot::DeviceProperties_PropertiesEntry_DoNotUse::InitAsDefaultInstance();
}

void InitDefaultsDeviceProperties_PropertiesEntry_DoNotUse() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDeviceProperties_PropertiesEntry_DoNotUseImpl);
}

void InitDefaultsDevicePropertiesImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_device_5fproperties_2eproto::InitDefaultsDeviceProperties_PropertiesEntry_DoNotUse();
  {
    void* ptr = &::mascot::_DeviceProperties_default_instance_;
    new (ptr) ::mascot::DeviceProperties();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DeviceProperties::InitAsDefaultInstance();
}

void InitDefaultsDeviceProperties() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDevicePropertiesImpl);
}

void InitDefaultsReadDeviceAttributeMetaMessageImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_ReadDeviceAttributeMetaMessage_default_instance_;
    new (ptr) ::mascot::ReadDeviceAttributeMetaMessage();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::ReadDeviceAttributeMetaMessage::InitAsDefaultInstance();
}

void InitDefaultsReadDeviceAttributeMetaMessage() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsReadDeviceAttributeMetaMessageImpl);
}

void InitDefaultsDeviceAttributeMeta_MetaEntry_DoNotUseImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_DeviceAttributeMeta_MetaEntry_DoNotUse_default_instance_;
    new (ptr) ::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse();
  }
  ::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse::InitAsDefaultInstance();
}

void InitDefaultsDeviceAttributeMeta_MetaEntry_DoNotUse() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDeviceAttributeMeta_MetaEntry_DoNotUseImpl);
}

void InitDefaultsDeviceAttributeMetaImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_device_5fproperties_2eproto::InitDefaultsDeviceAttributeMeta_MetaEntry_DoNotUse();
  {
    void* ptr = &::mascot::_DeviceAttributeMeta_default_instance_;
    new (ptr) ::mascot::DeviceAttributeMeta();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DeviceAttributeMeta::InitAsDefaultInstance();
}

void InitDefaultsDeviceAttributeMeta() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDeviceAttributeMetaImpl);
}

::google::protobuf::Metadata file_level_metadata[6];

const ::google::protobuf::uint32 TableStruct::offsets[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ReadDevicePropertiesMessage, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ReadDevicePropertiesMessage, devicename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceProperties_PropertiesEntry_DoNotUse, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceProperties_PropertiesEntry_DoNotUse, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceProperties_PropertiesEntry_DoNotUse, key_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceProperties_PropertiesEntry_DoNotUse, value_),
  0,
  1,
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceProperties, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceProperties, devicename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceProperties, properties_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ReadDeviceAttributeMetaMessage, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ReadDeviceAttributeMetaMessage, devicename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ReadDeviceAttributeMetaMessage, attributename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse, key_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse, value_),
  0,
  1,
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeMeta, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeMeta, devicename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeMeta, attributename_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeMeta, meta_),
};
static const ::google::protobuf::internal::MigrationSchema schemas[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  { 0, -1, sizeof(::mascot::ReadDevicePropertiesMessage)},
  { 6, 13, sizeof(::mascot::DeviceProperties_PropertiesEntry_DoNotUse)},
  { 15, -1, sizeof(::mascot::DeviceProperties)},
  { 22, -1, sizeof(::mascot::ReadDeviceAttributeMetaMessage)},
  { 29, 36, sizeof(::mascot::DeviceAttributeMeta_MetaEntry_DoNotUse)},
  { 38, -1, sizeof(::mascot::DeviceAttributeMeta)},
};

static ::google::protobuf::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_ReadDevicePropertiesMessage_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceProperties_PropertiesEntry_DoNotUse_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceProperties_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_ReadDeviceAttributeMetaMessage_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceAttributeMeta_MetaEntry_DoNotUse_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceAttributeMeta_default_instance_),
};

void protobuf_AssignDescriptors() {
  AddDescriptors();
  ::google::protobuf::MessageFactory* factory = NULL;
  AssignDescriptors(
      "device_properties.proto", schemas, file_default_instances, TableStruct::offsets, factory,
      file_level_metadata, NULL, NULL);
}

void protobuf_AssignDescriptorsOnce() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &protobuf_AssignDescriptors);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_PROTOBUF_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::internal::RegisterAllTypes(file_level_metadata, 6);
}

void AddDescriptorsImpl() {
  InitDefaults();
  static const char descriptor[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
      "\n\027device_properties.proto\022\006mascot\032\013value"
      ".proto\"1\n\033ReadDevicePropertiesMessage\022\022\n"
      "\ndeviceName\030\001 \001(\t\"\257\001\n\020DeviceProperties\022\022"
      "\n\ndeviceName\030\001 \001(\t\022<\n\nproperties\030\002 \003(\0132("
      ".mascot.DeviceProperties.PropertiesEntry"
      "\032I\n\017PropertiesEntry\022\013\n\003key\030\001 \001(\t\022%\n\005valu"
      "e\030\002 \001(\0132\026.mascot.AttributeValue:\0028\001\"K\n\036R"
      "eadDeviceAttributeMetaMessage\022\022\n\ndeviceN"
      "ame\030\001 \001(\t\022\025\n\rattributeName\030\002 \001(\t\"\242\001\n\023Dev"
      "iceAttributeMeta\022\022\n\ndeviceName\030\001 \001(\t\022\025\n\r"
      "attributeName\030\002 \001(\t\0223\n\004meta\030\003 \003(\0132%.masc"
      "ot.DeviceAttributeMeta.MetaEntry\032+\n\tMeta"
      "Entry\022\013\n\003key\030\001 \001(\t\022\r\n\005value\030\002 \001(\t:\0028\001b\006p"
      "roto3"
  };
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
      descriptor, 525);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "device_properties.proto", &protobuf_RegisterTypes);
  ::protobuf_value_2eproto::AddDescriptors();
}

void AddDescriptors() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &AddDescriptorsImpl);
}
// Force AddDescriptors() to be called at dynamic initialization time.
struct StaticDescriptorInitializer {
  StaticDescriptorInitializer() {
    AddDescriptors();
  }
} static_descriptor_initializer;
}  // namespace protobuf_device_5fproperties_2eproto
namespace mascot {

// ===================================================================

void ReadDevicePropertiesMessage::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int ReadDevicePropertiesMessage::kDeviceNameFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

ReadDevicePropertiesMessage::ReadDevicePropertiesMessage()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_5fproperties_2eproto::InitDefaultsReadDevicePropertiesMessage();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.ReadDevicePropertiesMessage)
}
ReadDevicePropertiesMessage::ReadDevicePropertiesMessage(const ReadDevicePropertiesMessage& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.devicename().size() > 0) {
    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.ReadDevicePropertiesMessage)
}

void ReadDevicePropertiesMessage::SharedCtor() {
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

ReadDevicePropertiesMessage::~ReadDevicePropertiesMessage() {
  // @@protoc_insertion_point(destructor:mascot.ReadDevicePropertiesMessage)
  SharedDtor();
}

void ReadDevicePropertiesMessage::SharedDtor() {
  devicename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void ReadDevicePropertiesMessage::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* ReadDevicePropertiesMessage::descriptor() {
  ::protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const ReadDevicePropertiesMessage& ReadDevicePropertiesMessage::default_instance() {
  ::protobuf_device_5fproperties_2eproto::InitDefaultsReadDevicePropertiesMessage();
  return *internal_default_instance();
}

ReadDevicePropertiesMessage* ReadDevicePropertiesMessage::New(::google::protobuf::Arena* arena) const {
  ReadDevicePropertiesMessage* n = new ReadDevicePropertiesMessage;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void ReadDevicePropertiesMessage::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.ReadDevicePropertiesMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool ReadDevicePropertiesMessage::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.ReadDevicePropertiesMessage)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string deviceName = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_devicename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->devicename().data(), static_cast<int>(this->devicename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.ReadDevicePropertiesMessage.deviceName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.ReadDevicePropertiesMessage)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.ReadDevicePropertiesMessage)
  return false;
#undef DO_
}

void ReadDevicePropertiesMessage::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.ReadDevicePropertiesMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDevicePropertiesMessage.deviceName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->devicename(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.ReadDevicePropertiesMessage)
}

::google::protobuf::uint8* ReadDevicePropertiesMessage::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.ReadDevicePropertiesMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDevicePropertiesMessage.deviceName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->devicename(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.ReadDevicePropertiesMessage)
  return target;
}

size_t ReadDevicePropertiesMessage::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.ReadDevicePropertiesMessage)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->devicename());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void ReadDevicePropertiesMessage::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.ReadDevicePropertiesMessage)
  GOOGLE_DCHECK_NE(&from, this);
  const ReadDevicePropertiesMessage* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const ReadDevicePropertiesMessage>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.ReadDevicePropertiesMessage)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.ReadDevicePropertiesMessage)
    MergeFrom(*source);
  }
}

void ReadDevicePropertiesMessage::MergeFrom(const ReadDevicePropertiesMessage& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.ReadDevicePropertiesMessage)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.devicename().size() > 0) {

    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
}

void ReadDevicePropertiesMessage::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.ReadDevicePropertiesMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void ReadDevicePropertiesMessage::CopyFrom(const ReadDevicePropertiesMessage& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.ReadDevicePropertiesMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ReadDevicePropertiesMessage::IsInitialized() const {
  return true;
}

void ReadDevicePropertiesMessage::Swap(ReadDevicePropertiesMessage* other) {
  if (other == this) return;
  InternalSwap(other);
}
void ReadDevicePropertiesMessage::InternalSwap(ReadDevicePropertiesMessage* other) {
  using std::swap;
  devicename_.Swap(&other->devicename_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata ReadDevicePropertiesMessage::GetMetadata() const {
  protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

DeviceProperties_PropertiesEntry_DoNotUse::DeviceProperties_PropertiesEntry_DoNotUse() {}
DeviceProperties_PropertiesEntry_DoNotUse::DeviceProperties_PropertiesEntry_DoNotUse(::google::protobuf::Arena* arena) : SuperType(arena) {}
void DeviceProperties_PropertiesEntry_DoNotUse::MergeFrom(const DeviceProperties_PropertiesEntry_DoNotUse& other) {
  MergeFromInternal(other);
}
::google::protobuf::Metadata DeviceProperties_PropertiesEntry_DoNotUse::GetMetadata() const {
  ::protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[1];
}
void DeviceProperties_PropertiesEntry_DoNotUse::MergeFrom(
    const ::google::protobuf::Message& other) {
  ::google::protobuf::Message::MergeFrom(other);
}


// ===================================================================

void DeviceProperties::InitAsDefaultInstance() {
}
void DeviceProperties::clear_properties() {
  properties_.Clear();
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DeviceProperties::kDeviceNameFieldNumber;
const int DeviceProperties::kPropertiesFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DeviceProperties::DeviceProperties()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_5fproperties_2eproto::InitDefaultsDeviceProperties();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DeviceProperties)
}
DeviceProperties::DeviceProperties(const DeviceProperties& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  properties_.MergeFrom(from.properties_);
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.devicename().size() > 0) {
    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.DeviceProperties)
}

void DeviceProperties::SharedCtor() {
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

DeviceProperties::~DeviceProperties() {
  // @@protoc_insertion_point(destructor:mascot.DeviceProperties)
  SharedDtor();
}

void DeviceProperties::SharedDtor() {
  devicename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void DeviceProperties::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DeviceProperties::descriptor() {
  ::protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DeviceProperties& DeviceProperties::default_instance() {
  ::protobuf_device_5fproperties_2eproto::InitDefaultsDeviceProperties();
  return *internal_default_instance();
}

DeviceProperties* DeviceProperties::New(::google::protobuf::Arena* arena) const {
  DeviceProperties* n = new DeviceProperties;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DeviceProperties::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DeviceProperties)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  properties_.Clear();
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool DeviceProperties::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DeviceProperties)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string deviceName = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_devicename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->devicename().data(), static_cast<int>(this->devicename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceProperties.deviceName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // map<string, .mascot.AttributeValue> properties = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DeviceProperties_PropertiesEntry_DoNotUse::Parser< ::google::protobuf::internal::MapField<
              DeviceProperties_PropertiesEntry_DoNotUse,
              ::std::string, ::mascot::AttributeValue,
              ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
              ::google::protobuf::internal::WireFormatLite::TYPE_MESSAGE,
              0 >,
            ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue > > parser(&properties_);
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
              input, &parser));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            parser.key().data(), static_cast<int>(parser.key().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceProperties.PropertiesEntry.key"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DeviceProperties)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DeviceProperties)
  return false;
#undef DO_
}

void DeviceProperties::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DeviceProperties)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceProperties.deviceName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->devicename(), output);
  }

  // map<string, .mascot.AttributeValue> properties = 2;
  if (!this->properties().empty()) {
    typedef ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::google::protobuf::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceProperties.PropertiesEntry.key");
      }
    };

    if (output->IsSerializationDeterministic() &&
        this->properties().size() > 1) {
      ::google::protobuf::scoped_array<SortItem> items(
          new SortItem[this->properties().size()]);
      typedef ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::size_type size_type;
      size_type n = 0;
      for (::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::const_iterator
          it = this->properties().begin();
          it != this->properties().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      ::google::protobuf::scoped_ptr<DeviceProperties_PropertiesEntry_DoNotUse> entry;
      for (size_type i = 0; i < n; i++) {
        entry.reset(properties_.NewEntryWrapper(
            items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second));
        ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
            2, *entry, output);
        Utf8Check::Check(items[static_cast<ptrdiff_t>(i)]);
      }
    } else {
      ::google::protobuf::scoped_ptr<DeviceProperties_PropertiesEntry_DoNotUse> entry;
      for (::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::const_iterator
          it = this->properties().begin();
          it != this->properties().end(); ++it) {
        entry.reset(properties_.NewEntryWrapper(
            it->first, it->second));
        ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
            2, *entry, output);
        Utf8Check::Check(&*it);
      }
    }
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DeviceProperties)
}

::google::protobuf::uint8* DeviceProperties::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DeviceProperties)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceProperties.deviceName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->devicename(), target);
  }

  // map<string, .mascot.AttributeValue> properties = 2;
  if (!this->properties().empty()) {
    typedef ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::google::protobuf::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceProperties.PropertiesEntry.key");
      }
    };

    if (deterministic &&
        this->properties().size() > 1) {
      ::google::protobuf::scoped_array<SortItem> items(
          new SortItem[this->properties().size()]);
      typedef ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::size_type size_type;
      size_type n = 0;
      for (::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::const_iterator
          it = this->properties().begin();
          it != this->properties().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      ::google::protobuf::scoped_ptr<DeviceProperties_PropertiesEntry_DoNotUse> entry;
      for (size_type i = 0; i < n; i++) {
        entry.reset(properties_.NewEntryWrapper(
            items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second));
        target = ::google::protobuf::internal::WireFormatLite::
                   InternalWriteMessageNoVirtualToArray(
                       2, *entry, deterministic, target);
;
        Utf8Check::Check(items[static_cast<ptrdiff_t>(i)]);
      }
    } else {
      ::google::protobuf::scoped_ptr<DeviceProperties_PropertiesEntry_DoNotUse> entry;
      for (::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::const_iterator
          it = this->properties().begin();
          it != this->properties().end(); ++it) {
        entry.reset(properties_.NewEntryWrapper(
            it->first, it->second));
        target = ::google::protobuf::internal::WireFormatLite::
                   InternalWriteMessageNoVirtualToArray(
                       2, *entry, deterministic, target);
;
        Utf8Check::Check(&*it);
      }
    }
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DeviceProperties)
  return target;
}

size_t DeviceProperties::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DeviceProperties)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // map<string, .mascot.AttributeValue> properties = 2;
  total_size += 1 *
      ::google::protobuf::internal::FromIntSize(this->properties_size());
  {
    ::google::protobuf::scoped_ptr<DeviceProperties_PropertiesEntry_DoNotUse> entry;
    for (::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >::const_iterator
        it = this->properties().begin();
        it != this->properties().end(); ++it) {
      entry.reset(properties_.NewEntryWrapper(it->first, it->second));
      total_size += ::google::protobuf::internal::WireFormatLite::
          MessageSizeNoVirtual(*entry);
    }
  }

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->devicename());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DeviceProperties::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DeviceProperties)
  GOOGLE_DCHECK_NE(&from, this);
  const DeviceProperties* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DeviceProperties>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DeviceProperties)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DeviceProperties)
    MergeFrom(*source);
  }
}

void DeviceProperties::MergeFrom(const DeviceProperties& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DeviceProperties)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  properties_.MergeFrom(from.properties_);
  if (from.devicename().size() > 0) {

    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
}

void DeviceProperties::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DeviceProperties)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DeviceProperties::CopyFrom(const DeviceProperties& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DeviceProperties)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DeviceProperties::IsInitialized() const {
  return true;
}

void DeviceProperties::Swap(DeviceProperties* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DeviceProperties::InternalSwap(DeviceProperties* other) {
  using std::swap;
  properties_.Swap(&other->properties_);
  devicename_.Swap(&other->devicename_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DeviceProperties::GetMetadata() const {
  protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void ReadDeviceAttributeMetaMessage::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int ReadDeviceAttributeMetaMessage::kDeviceNameFieldNumber;
const int ReadDeviceAttributeMetaMessage::kAttributeNameFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

ReadDeviceAttributeMetaMessage::ReadDeviceAttributeMetaMessage()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_5fproperties_2eproto::InitDefaultsReadDeviceAttributeMetaMessage();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.ReadDeviceAttributeMetaMessage)
}
ReadDeviceAttributeMetaMessage::ReadDeviceAttributeMetaMessage(const ReadDeviceAttributeMetaMessage& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.devicename().size() > 0) {
    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  attributename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.attributename().size() > 0) {
    attributename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.attributename_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.ReadDeviceAttributeMetaMessage)
}

void ReadDeviceAttributeMetaMessage::SharedCtor() {
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

ReadDeviceAttributeMetaMessage::~ReadDeviceAttributeMetaMessage() {
  // @@protoc_insertion_point(destructor:mascot.ReadDeviceAttributeMetaMessage)
  SharedDtor();
}

void ReadDeviceAttributeMetaMessage::SharedDtor() {
  devicename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void ReadDeviceAttributeMetaMessage::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* ReadDeviceAttributeMetaMessage::descriptor() {
  ::protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const ReadDeviceAttributeMetaMessage& ReadDeviceAttributeMetaMessage::default_instance() {
  ::protobuf_device_5fproperties_2eproto::InitDefaultsReadDeviceAttributeMetaMessage();
  return *internal_default_instance();
}

ReadDeviceAttributeMetaMessage* ReadDeviceAttributeMetaMessage::New(::google::protobuf::Arena* arena) const {
  ReadDeviceAttributeMetaMessage* n = new ReadDeviceAttributeMetaMessage;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void ReadDeviceAttributeMetaMessage::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.ReadDeviceAttributeMetaMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool ReadDeviceAttributeMetaMessage::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.ReadDeviceAttributeMetaMessage)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string deviceName = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_devicename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->devicename().data(), static_cast<int>(this->devicename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.ReadDeviceAttributeMetaMessage.deviceName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string attributeName = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_attributename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->attributename().data(), static_cast<int>(this->attributename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.ReadDeviceAttributeMetaMessage.attributeName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.ReadDeviceAttributeMetaMessage)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.ReadDeviceAttributeMetaMessage)
  return false;
#undef DO_
}

void ReadDeviceAttributeMetaMessage::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.ReadDeviceAttributeMetaMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDeviceAttributeMetaMessage.deviceName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->devicename(), output);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->attributename().data(), static_cast<int>(this->attributename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDeviceAttributeMetaMessage.attributeName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      2, this->attributename(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.ReadDeviceAttributeMetaMessage)
}

::google::protobuf::uint8* ReadDeviceAttributeMetaMessage::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.ReadDeviceAttributeMetaMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDeviceAttributeMetaMessage.deviceName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->devicename(), target);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->attributename().data(), static_cast<int>(this->attributename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.ReadDeviceAttributeMetaMessage.attributeName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        2, this->attributename(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.ReadDeviceAttributeMetaMessage)
  return target;
}

size_t ReadDeviceAttributeMetaMessage::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.ReadDeviceAttributeMetaMessage)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->devicename());
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->attributename());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void ReadDeviceAttributeMetaMessage::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.ReadDeviceAttributeMetaMessage)
  GOOGLE_DCHECK_NE(&from, this);
  const ReadDeviceAttributeMetaMessage* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const ReadDeviceAttributeMetaMessage>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.ReadDeviceAttributeMetaMessage)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.ReadDeviceAttributeMetaMessage)
    MergeFrom(*source);
  }
}

void ReadDeviceAttributeMetaMessage::MergeFrom(const ReadDeviceAttributeMetaMessage& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.ReadDeviceAttributeMetaMessage)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.devicename().size() > 0) {

    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  if (from.attributename().size() > 0) {

    attributename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.attributename_);
  }
}

void ReadDeviceAttributeMetaMessage::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.ReadDeviceAttributeMetaMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void ReadDeviceAttributeMetaMessage::CopyFrom(const ReadDeviceAttributeMetaMessage& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.ReadDeviceAttributeMetaMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ReadDeviceAttributeMetaMessage::IsInitialized() const {
  return true;
}

void ReadDeviceAttributeMetaMessage::Swap(ReadDeviceAttributeMetaMessage* other) {
  if (other == this) return;
  InternalSwap(other);
}
void ReadDeviceAttributeMetaMessage::InternalSwap(ReadDeviceAttributeMetaMessage* other) {
  using std::swap;
  devicename_.Swap(&other->devicename_);
  attributename_.Swap(&other->attributename_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata ReadDeviceAttributeMetaMessage::GetMetadata() const {
  protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

DeviceAttributeMeta_MetaEntry_DoNotUse::DeviceAttributeMeta_MetaEntry_DoNotUse() {}
DeviceAttributeMeta_MetaEntry_DoNotUse::DeviceAttributeMeta_MetaEntry_DoNotUse(::google::protobuf::Arena* arena) : SuperType(arena) {}
void DeviceAttributeMeta_MetaEntry_DoNotUse::MergeFrom(const DeviceAttributeMeta_MetaEntry_DoNotUse& other) {
  MergeFromInternal(other);
}
::google::protobuf::Metadata DeviceAttributeMeta_MetaEntry_DoNotUse::GetMetadata() const {
  ::protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[4];
}
void DeviceAttributeMeta_MetaEntry_DoNotUse::MergeFrom(
    const ::google::protobuf::Message& other) {
  ::google::protobuf::Message::MergeFrom(other);
}


// ===================================================================

void DeviceAttributeMeta::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DeviceAttributeMeta::kDeviceNameFieldNumber;
const int DeviceAttributeMeta::kAttributeNameFieldNumber;
const int DeviceAttributeMeta::kMetaFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DeviceAttributeMeta::DeviceAttributeMeta()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_5fproperties_2eproto::InitDefaultsDeviceAttributeMeta();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DeviceAttributeMeta)
}
DeviceAttributeMeta::DeviceAttributeMeta(const DeviceAttributeMeta& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  meta_.MergeFrom(from.meta_);
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.devicename().size() > 0) {
    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  attributename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.attributename().size() > 0) {
    attributename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.attributename_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.DeviceAttributeMeta)
}

void DeviceAttributeMeta::SharedCtor() {
  devicename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

DeviceAttributeMeta::~DeviceAttributeMeta() {
  // @@protoc_insertion_point(destructor:mascot.DeviceAttributeMeta)
  SharedDtor();
}

void DeviceAttributeMeta::SharedDtor() {
  devicename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void DeviceAttributeMeta::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DeviceAttributeMeta::descriptor() {
  ::protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DeviceAttributeMeta& DeviceAttributeMeta::default_instance() {
  ::protobuf_device_5fproperties_2eproto::InitDefaultsDeviceAttributeMeta();
  return *internal_default_instance();
}

DeviceAttributeMeta* DeviceAttributeMeta::New(::google::protobuf::Arena* arena) const {
  DeviceAttributeMeta* n = new DeviceAttributeMeta;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DeviceAttributeMeta::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DeviceAttributeMeta)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  meta_.Clear();
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool DeviceAttributeMeta::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DeviceAttributeMeta)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string deviceName = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_devicename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->devicename().data(), static_cast<int>(this->devicename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceAttributeMeta.deviceName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string attributeName = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_attributename()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->attributename().data(), static_cast<int>(this->attributename().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceAttributeMeta.attributeName"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // map<string, string> meta = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(26u /* 26 & 0xFF */)) {
          DeviceAttributeMeta_MetaEntry_DoNotUse::Parser< ::google::protobuf::internal::MapField<
              DeviceAttributeMeta_MetaEntry_DoNotUse,
              ::std::string, ::std::string,
              ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
              ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
              0 >,
            ::google::protobuf::Map< ::std::string, ::std::string > > parser(&meta_);
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
              input, &parser));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            parser.key().data(), static_cast<int>(parser.key().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceAttributeMeta.MetaEntry.key"));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            parser.value().data(), static_cast<int>(parser.value().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceAttributeMeta.MetaEntry.value"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DeviceAttributeMeta)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DeviceAttributeMeta)
  return false;
#undef DO_
}

void DeviceAttributeMeta::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DeviceAttributeMeta)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceAttributeMeta.deviceName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->devicename(), output);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->attributename().data(), static_cast<int>(this->attributename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceAttributeMeta.attributeName");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      2, this->attributename(), output);
  }

  // map<string, string> meta = 3;
  if (!this->meta().empty()) {
    typedef ::google::protobuf::Map< ::std::string, ::std::string >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::google::protobuf::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceAttributeMeta.MetaEntry.key");
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->second.data(), static_cast<int>(p->second.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceAttributeMeta.MetaEntry.value");
      }
    };

    if (output->IsSerializationDeterministic() &&
        this->meta().size() > 1) {
      ::google::protobuf::scoped_array<SortItem> items(
          new SortItem[this->meta().size()]);
      typedef ::google::protobuf::Map< ::std::string, ::std::string >::size_type size_type;
      size_type n = 0;
      for (::google::protobuf::Map< ::std::string, ::std::string >::const_iterator
          it = this->meta().begin();
          it != this->meta().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      ::google::protobuf::scoped_ptr<DeviceAttributeMeta_MetaEntry_DoNotUse> entry;
      for (size_type i = 0; i < n; i++) {
        entry.reset(meta_.NewEntryWrapper(
            items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second));
        ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
            3, *entry, output);
        Utf8Check::Check(items[static_cast<ptrdiff_t>(i)]);
      }
    } else {
      ::google::protobuf::scoped_ptr<DeviceAttributeMeta_MetaEntry_DoNotUse> entry;
      for (::google::protobuf::Map< ::std::string, ::std::string >::const_iterator
          it = this->meta().begin();
          it != this->meta().end(); ++it) {
        entry.reset(meta_.NewEntryWrapper(
            it->first, it->second));
        ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
            3, *entry, output);
        Utf8Check::Check(&*it);
      }
    }
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DeviceAttributeMeta)
}

::google::protobuf::uint8* DeviceAttributeMeta::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DeviceAttributeMeta)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->devicename().data(), static_cast<int>(this->devicename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceAttributeMeta.deviceName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->devicename(), target);
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->attributename().data(), static_cast<int>(this->attributename().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceAttributeMeta.attributeName");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        2, this->attributename(), target);
  }

  // map<string, string> meta = 3;
  if (!this->meta().empty()) {
    typedef ::google::protobuf::Map< ::std::string, ::std::string >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::google::protobuf::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceAttributeMeta.MetaEntry.key");
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->second.data(), static_cast<int>(p->second.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceAttributeMeta.MetaEntry.value");
      }
    };

    if (deterministic &&
        this->meta().size() > 1) {
      ::google::protobuf::scoped_array<SortItem> items(
          new SortItem[this->meta().size()]);
      typedef ::google::protobuf::Map< ::std::string, ::std::string >::size_type size_type;
      size_type n = 0;
      for (::google::protobuf::Map< ::std::string, ::std::string >::const_iterator
          it = this->meta().begin();
          it != this->meta().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      ::google::protobuf::scoped_ptr<DeviceAttributeMeta_MetaEntry_DoNotUse> entry;
      for (size_type i = 0; i < n; i++) {
        entry.reset(meta_.NewEntryWrapper(
            items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second));
        target = ::google::protobuf::internal::WireFormatLite::
                   InternalWriteMessageNoVirtualToArray(
                       3, *entry, deterministic, target);
;
        Utf8Check::Check(items[static_cast<ptrdiff_t>(i)]);
      }
    } else {
      ::google::protobuf::scoped_ptr<DeviceAttributeMeta_MetaEntry_DoNotUse> entry;
      for (::google::protobuf::Map< ::std::string, ::std::string >::const_iterator
          it = this->meta().begin();
          it != this->meta().end(); ++it) {
        entry.reset(meta_.NewEntryWrapper(
            it->first, it->second));
        target = ::google::protobuf::internal::WireFormatLite::
                   InternalWriteMessageNoVirtualToArray(
                       3, *entry, deterministic, target);
;
        Utf8Check::Check(&*it);
      }
    }
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DeviceAttributeMeta)
  return target;
}

size_t DeviceAttributeMeta::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DeviceAttributeMeta)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // map<string, string> meta = 3;
  total_size += 1 *
      ::google::protobuf::internal::FromIntSize(this->meta_size());
  {
    ::google::protobuf::scoped_ptr<DeviceAttributeMeta_MetaEntry_DoNotUse> entry;
    for (::google::protobuf::Map< ::std::string, ::std::string >::const_iterator
        it = this->meta().begin();
        it != this->meta().end(); ++it) {
      entry.reset(meta_.NewEntryWrapper(it->first, it->second));
      total_size += ::google::protobuf::internal::WireFormatLite::
          MessageSizeNoVirtual(*entry);
    }
  }

  // string deviceName = 1;
  if (this->devicename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->devicename());
  }

  // string attributeName = 2;
  if (this->attributename().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->attributename());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DeviceAttributeMeta::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DeviceAttributeMeta)
  GOOGLE_DCHECK_NE(&from, this);
  const DeviceAttributeMeta* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DeviceAttributeMeta>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DeviceAttributeMeta)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DeviceAttributeMeta)
    MergeFrom(*source);
  }
}

void DeviceAttributeMeta::MergeFrom(const DeviceAttributeMeta& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DeviceAttributeMeta)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  meta_.MergeFrom(from.meta_);
  if (from.devicename().size() > 0) {

    devicename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.devicename_);
  }
  if (from.attributename().size() > 0) {

    attributename_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.attributename_);
  }
}

void DeviceAttributeMeta::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DeviceAttributeMeta)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DeviceAttributeMeta::CopyFrom(const DeviceAttributeMeta& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DeviceAttributeMeta)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DeviceAttributeMeta::IsInitialized() const {
  return true;
}

void DeviceAttributeMeta::Swap(DeviceAttributeMeta* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DeviceAttributeMeta::InternalSwap(DeviceAttributeMeta* other) {
  using std::swap;
  meta_.Swap(&other->meta_);
  devicename_.Swap(&other->devicename_);
  attributename_.Swap(&other->attributename_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DeviceAttributeMeta::GetMetadata() const {
  protobuf_device_5fproperties_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_5fproperties_2eproto::file_level_metadata[kIndexInFileMessages];
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace mascot

// @@protoc_insertion_point(global_scope)
